import java.util.HashMap;
import java.util.Iterator;

// https://docs.oracle.com/javase/jp/8/docs/api/java/util/HashMap.html
public class HashMapSample {

    public static void main(String args[]) {
        // create HashMap
        HashMap<String, Integer> hm = new HashMap<String, Integer>();
        // put
        System.out.println("-- put(key, value) --");
        hm.put("a", 10);
        hm.put("b", 20);
        System.out.println("a: " + hm.get("a"));
        System.out.println("b: " + hm.get("b"));

        // Java8 later (replace method)
        System.out.println("-- replace(key, value) --");
        hm.replace("a",100);
        hm.replace("b",200);
        System.out.println("a: " + hm.get("a"));
        System.out.println("b: " + hm.get("b"));

        // Java8 later (replace method)
        System.out.println("-- replace(key, value, value) --");
        hm.replace("a",100, 1000);
        hm.replace("b",200, 2000);
        System.out.println("a: " + hm.get("a"));
        System.out.println("b: " + hm.get("b"));

        // remove
        System.out.println("-- remove --");
        hm.remove("a");
        System.out.println("a: " + hm.get("a"));
        System.out.println("b: " + hm.get("b"));

        // clear
        System.out.println("-- clear --");
        hm.clear();
        System.out.println("hm.size() : " + hm.size());

        hm.put("one", 1);
        hm.put("two", 2);
        hm.put("three", 3);

        // get key list
        System.out.println("-- keySet --");
        for(String key : hm.keySet()) {
            System.out.println(key);
        }

        // get key list
        System.out.println("-- iterator --");
        for(Iterator<String> iterator = hm.keySet().iterator(); iterator.hasNext();) {
            String key = iterator.next();
            System.out.println(key);
        }

        // get key and value list
        System.out.println("-- keySet (key and value) --");
        for(String key : hm.keySet()) {
            System.out.println(key + ": " + hm.get(key));
        }
    }
}

